#include "chdecl.h"
void CH_codegen_exprassemble(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto c18;
    case 4: goto cb19;
    case 5: goto c20;
    case 6: goto c23;
    case 7: goto c40;
    case 8: goto c70;
    case 9: goto c72;
    case 10: goto c73;
    case 11: goto c78;
    case 12: goto c85;
    case 13: goto c88;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* case 4 3.0 */
  REF(4).value.enumeration = REF(3)DOT(0).value.variant->info.variant_case;
  REF(4).tsdr = & dr_enumeration;
/* equal . 4 =(1) , 10 */
  if ( REF(4).value.enumeration == 1 ) goto c10;
/* equal . 4 =(0) , 70 */
  if ( REF(4).value.enumeration == 0 ) goto c70;
/* branch , 72 */
   goto c72;
c10:
/* reveal 3.0 , 1 */
  if (1 != REF(3)DOT(0).value.variant->info.variant_case) goto ch_case_error;
/* new_table 3.1 , 2 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(1),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* currentprogram 5 */
  if ((ch_val.program = make_pgm_copy(sched->ready->prog)) == nil)
     goto ch_depletion;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val; REF(5).tsdr = & dr_program;
/* procedure 6 5 , 3 */
  if ((ch_returncode = che_procedure(DEF(6),DEF(5),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* move 7 6 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7) = REF(6);
  REF(6).tsdr = & dr_bottom;
/* copy 8 3.0.0.3 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0)DOT(0)DOT(3).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val;
  REF(8).tsdr = & dr_table;
/* initget 9 8 , 0,0 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(9),DEF(8),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c18:
/* get_or_goto 9 8 , 23 */
  if ((ch_returncode = get_selected_object(DEF(9),DEF(8),sched)) != Normal)
     goto c23;
  current->ip = 4;
cb19:
/* call 7 9 10 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7),
          arguments[1] = DEF(9),
          arguments[2] = DEF(10),
          arguments[2+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c20:
/* noop */
  
/* merge 3.1 10 */
  if ((ch_returncode = mergefunc(DEF(3)DOT(1),DEF(10),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 18 */
   goto c18;
c23:
/* endget 9 8 */
  end_selector(DEF(9),DEF(8),sched,GET);
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* new_record 11 , 5 */
  if ((ch_val.record = new_record(5)) == nil) goto ch_depletion;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val; REF(11).tsdr = & dr_record;
/* unique 11.0 */
  if ((ch_returncode = che_unique(DEF(11)DOT(0),sched)) != Normal)
     goto ch_raise_exception;
/* copy 11.1 3.0.0.0 */
  REF(11)DOT(1) = REF(3)DOT(0)DOT(0)DOT(0);
/* new_table 11.2 , 5 */
  if ((ch_returncode = che_new_table(DEF(11)DOT(2),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* notequal 12 11.1 =(5) */
  REF(12).value.boolean = (REF(11)DOT(1).value.ord_enum != 5);
  REF(12).tsdr = & dr_boolean;
/* notequal 13 11.1 =(23) */
  REF(13).value.boolean = (REF(11)DOT(1).value.ord_enum != 23);
  REF(13).tsdr = & dr_boolean;
/* and 14 12 13 */
  REF(14).value.boolean = REF(12).value.boolean&REF(13).value.boolean;
  REF(14).tsdr = & dr_boolean;
/* branch_false 14 , 38 */
  if ( !REF(14).value.boolean ) goto c38;
/* copy 15 3.0.0.2 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0)DOT(2).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).value = ch_val;
  REF(15).tsdr = datarepmap[REF(3)DOT(0)DOT(0)DOT(2).tsdr->number];
/* insert 11.2 15 */
  if ((ch_returncode = insertfunc(DEF(11)DOT(2),DEF(15),FALSE,0)) != Normal)
     goto ch_raise_exception;
c38:
/* copy 16 3.0.0.3 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0)DOT(0)DOT(3).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  REF(16).value = ch_val;
  REF(16).tsdr = & dr_table;
/* initget 17 16 , 0,0 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(17),DEF(16),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c40:
/* get_or_goto 17 16 , 59 */
  if ((ch_returncode = get_selected_object(DEF(17),DEF(16),sched)) != Normal)
     goto c59;
/* case 18 17 */
  REF(18).value.enumeration = REF(17).value.variant->info.variant_case;
  REF(18).tsdr = & dr_enumeration;
/* equal . 18 =(1) , 48 */
  if ( REF(18).value.enumeration == 1 ) goto c48;
/* equal . 18 =(0) , 52 */
  if ( REF(18).value.enumeration == 0 ) goto c52;
/* branch , 56 */
   goto c56;
c48:
/* reveal 17 , 1 */
  if (1 != REF(17).value.variant->info.variant_case) goto ch_case_error;
/* copy 19 17.0.2 */
  if((ch_returncode = (REF(17)DOT(0)DOT(2).tsdr->copy)(& ch_val, 
    REF(17)DOT(0)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  REF(19).value = ch_val;
  REF(19).tsdr = datarepmap[REF(17)DOT(0)DOT(2).tsdr->number];
/* insert 11.2 19 */
  if ((ch_returncode = insertfunc(DEF(11)DOT(2),DEF(19),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 40 */
   goto c40;
c52:
/* reveal 17 , 0 */
  if (0 != REF(17).value.variant->info.variant_case) goto ch_case_error;
/* copy 20 17.0 */
  if((ch_returncode = (REF(17)DOT(0).tsdr->copy)(& ch_val, REF(17)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).value = ch_val;
  REF(20).tsdr = datarepmap[REF(17)DOT(0).tsdr->number];
/* insert 11.2 20 */
  if ((ch_returncode = insertfunc(DEF(11)DOT(2),DEF(20),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 40 */
   goto c40;
c56:
/* exit , 6 */
  ch_e = handler_type__exit; ch_val = QUAL(6); goto ch_exception;
c59:
/* endget 17 16 */
  end_selector(DEF(17),DEF(16),sched,GET);
/* discard 16 */
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  REF(16).tsdr = & dr_bottom;
/* notequal . 11.1 =(5) , 66 */
  if ( REF(11)DOT(1).value.ord_enum != 5 ) goto c66;
/* copy 21 3.0.0.2 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0)DOT(2).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).value = ch_val;
  REF(21).tsdr = datarepmap[REF(3)DOT(0)DOT(0)DOT(2).tsdr->number];
/* insert 11.2 21 */
  if ((ch_returncode = insertfunc(DEF(11)DOT(2),DEF(21),FALSE,0)) != Normal)
     goto ch_raise_exception;
c66:
/* copy 11.3 3.0.0.1 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0)DOT(1).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0)DOT(1).value)) != Normal) goto ch_raise_exception;
  (*(REF(11)DOT(3).tsdr)->finalize)(REF(11)DOT(3).value,F_DISCARD,sched);
  REF(11)DOT(3).value = ch_val;
  REF(11)DOT(3).tsdr = datarepmap[REF(3)DOT(0)DOT(0)DOT(1).tsdr->number];
/* copy 11.4 3.0.0.4 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0)DOT(4).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0)DOT(4).value)) != Normal) goto ch_raise_exception;
  (*(REF(11)DOT(4).tsdr)->finalize)(REF(11)DOT(4).value,F_DISCARD,sched);
  REF(11)DOT(4).value = ch_val;
  REF(11)DOT(4).tsdr = datarepmap[REF(3)DOT(0)DOT(0)DOT(4).tsdr->number];
/* insert 3.1 11 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(1),DEF(11),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 73 */
   goto c73;
c70:
/* new_table 3.1 , 2 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(1),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* branch , 73 */
   goto c73;
c72:
/* exit , 6 */
  ch_e = handler_type__exit; ch_val = QUAL(6); goto ch_exception;
c73:
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 85 */
   goto c85;
c78:
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* discard 3.1 */
  (*(REF(3)DOT(1).tsdr)->finalize)(REF(3)DOT(1).value,F_DISCARD,sched);
  REF(3)DOT(1).tsdr = & dr_bottom;
/* chs_lit 22 , "Exit to cantHappen in exprAssemble" */
  if( !chs_lit(DEF(22),"Exit to cantHappen in exprAssemble") )
     goto ch_depletion;
/* print 22 */
  re_print(stderr, 0, DEF(22)); fflush(stderr);
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
c85:
/* discard 3 */
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c88:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
